﻿using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApp72
{
    public partial class Form1 : Form
    {
        private DataTable dt = DummyDataCreator.GetData(10, new Type[] { typeof(string) });
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraCombo1.InitializeLayout += UltraCombo1_InitializeLayout;
            this.ultraCombo1.AfterDropDown += UltraCombo1_AfterDropDown;
            this.ultraCombo1.DataSource = dt;
        }

        private void UltraCombo1_AfterDropDown(object sender, EventArgs e)
        {
            this.ultraCombo1.AfterDropDown -= UltraCombo1_AfterDropDown;
            var control = Infragistics.Win.DropDownManager.GetCurrentDropDownControl(this.ultraCombo1);
            control.MouseUp += Control_MouseUp; 
        }

        private void Control_MouseUp(object sender, MouseEventArgs e)
        {
            var ultraControl = sender as IUltraControlElement;
            if (null == ultraControl)
                return;

            var mainUIElement = ultraControl.MainUIElement;
            if (null == mainUIElement)
                return;

            var clickedElement = mainUIElement.ElementFromPoint(e.Location);
            if (null == clickedElement)
                return;

            var header = clickedElement.GetContext(typeof(BandHeader)) as BandHeader;
            if (null != header)
            {
                var newRow = dt.Rows.Add();
                var comboRow = this.ultraCombo1.Rows.GetRowWithListIndex(dt.Rows.Count - 1);
                this.ultraCombo1.ActiveRow = comboRow;                
            }
        }

        private void UltraCombo1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            var layout = e.Layout;
            var band = layout.Bands[0];

            band.HeaderVisible = true;
            band.Header.Caption = "Add New Row";
        }
    }
}
